
(function ($) {
	$.Redactor.prototype.spoiler = function () {
		return {
			init: function () {
				var button = this.button.add('spoiler', 'Спойлер');
				this.button.addCallback(button, this.spoiler.insert);
			},
			insert: function () {
				
				content = this.selection.getHtml();

				(function () {
					this.uniqid = function (pr, en) {
						var pr = pr || '',
						en = en || false,
						result,
						us;

						this.seed = function (s, w) {
							s = parseInt(s, 10).toString(16);
							return w < s.length ? s.slice(s.length - w) :
							(w > s.length) ? new Array(1 + (w - s.length)).join('0') + s : s;
						};

						result = pr + this.seed(parseInt(new Date().getTime() / 1000, 10), 8)
							 + this.seed(Math.floor(Math.random() * 0x75bcd15) + 1, 5);

						if (en)
							result += (Math.random() * 10).toFixed(8).toString();

						return result;
					};
				})();
				spoiler_name = prompt('Название спойлера', 'Спойлер');
				
				uniq = uniqid();
				
				spoiler = '<span class="spoiler"><input tabindex="-1" type="checkbox" id="' + uniq + '"><label for="' + uniq + '">' + spoiler_name + '</label><span class="show_body">' + content + '</span></span>';
					
				this.insert.htmlWithoutClean(spoiler);
				
				$('.spoiler').removeAttr('span').addClass('spoiler');
				$('.show_body').removeAttr('span').addClass('spoiler_body');

			}

		};
	};
})(jQuery);
